-- Test order_campsite_type_features
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(11);

set search_path to camper, public;

select has_function('camper', 'order_campsite_type_features', array['integer[]']);
select function_lang_is('camper', 'order_campsite_type_features', array['integer[]'], 'sql');
select function_returns('camper', 'order_campsite_type_features', array['integer[]'], 'void');
select isnt_definer('camper', 'order_campsite_type_features', array['integer[]']);
select volatility_is('camper', 'order_campsite_type_features', array['integer[]'], 'volatile');
select function_privs_are('camper', 'order_campsite_type_features', array ['integer[]'], 'guest', array[]::text[]);
select function_privs_are('camper', 'order_campsite_type_features', array ['integer[]'], 'employee', array[]::text[]);
select function_privs_are('camper', 'order_campsite_type_features', array ['integer[]'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'order_campsite_type_features', array ['integer[]'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate campsite_type_feature cascade;
truncate campsite_type cascade;
truncate media cascade;
truncate media_content cascade;
truncate company_host cascade;
truncate company_user cascade;
truncate company cascade;
truncate auth."user" cascade;
reset client_min_messages;

insert into auth."user" (user_id, email, name, password, cookie, cookie_expires_at)
values (1, 'demo@tandem.blog', 'Demo', 'test', '44facbb30d8a419dfd4bfbc44a4b5539d4970148dfc84bed0e', current_timestamp + interval '1 month')
     , (5, 'admin@tandem.blog', 'Demo', 'test', '12af4c88b528c2ad4222e3740496ecbc58e76e26f087657524', current_timestamp + interval '1 month')
;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (2, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into company_user (company_id, user_id, role)
values (2, 1, 'admin')
;

insert into company_host (company_id, host)
values (2, 'co2')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (6, 2, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

insert into campsite_type (campsite_type_id, company_id, name, media_id, max_campers, bookable_nights)
values (16, 2, 'Wooden lodge', 6, 7, '[1, 7]')
;

insert into campsite_type_feature (campsite_type_feature_id, campsite_type_id, icon_name, name)
values (21, 16, 'information', '1')
     , (22, 16, 'ball', '2')
     , (23, 16, 'bicycle', '3')
     , (24, 16, 'campfire', '4')
     , (25, 16, 'castle', '5')
;


select lives_ok(
	$$ select order_campsite_type_features('{23,25,24,21,22}') $$,
	'Should be able to sort campsite type features using their ID'
);

select bag_eq(
	$$ select campsite_type_feature_id, position from campsite_type_feature $$,
	$$ values (23, 1)
	        , (25, 2)
	        , (24, 3)
	        , (21, 4)
	        , (22, 5)
	$$,
	'Should have sorted all campsite type features.'
);

select *
from finish();

rollback;
